#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "read-conf.h"

extern int errno;

// arquivo padrao para saida dos logs
#define SAIDA "/var/log/gklog"
// define se ele ir mostrar o resultado
// na tela por padro
#define MOSTRAR_DEFAULT 1

int Mostrar = MOSTRAR_DEFAULT;

/* define se o log ir ser mostrado inteiro ou apenas as partes que foram
definidas como regras... o padro  que seja mostrado todo */
int restrict = 0;

#define CONFFILE "/etc/gklog.rules"
char conf[256] = CONFFILE;  // Default conffile's name

int LerLog (char *arquivo, char* Saida)
{
    FILE* saida; // arquivo de sada
    FILE* log;
    char Linha[1024];
    char c;
    int i;

    if (!strcmp(arquivo, "-"))
    {
    	log = stdin;
    } // checa se trabalhamos com stdin
    else
    {
    	// arquivo original
	    log = fopen (arquivo, "r");
     }

    saida = fopen (Saida, "a");    // arquivo a ser criado

    if (saida == NULL)
    {
	perror("fopen(): saida");
	return 1;
    }

    if (log == NULL)
    {
	perror("fopen(): log");
	return 1;
    }

    while (!feof(log))
    {
	bzero (Linha, 1024); // zera Linha
	c = '\0'; // zera o caractere para q naum haja
	// problema caso ele seja '\n'
	for (i = 0 ; c != '\n' ; i++)
	{
	    c = fgetc(log);
	    if (c == EOF) // se o arquivo acabou
		goto fimda; // saia
	    Linha[i] = c;
	}
	fflush(log);
	Linha[i] = '\0';
	    fflush(saida);

	    if (Mostrar == 1) // mostrar no stdout
	    {
		if ( ProcessRules (Linha) == 1 )
		{
			fprintf (stdout, "%s", Linha);
	    		fprintf (saida, "%s", Linha);
			fprintf(stdout, "\033[0m");
			fflush (saida);
			fflush (stdout);
		}
		else
		{
			if (!restrict)
				fprintf(stdout, "%s", Linha);
		}
	    }
    }



fimda:
       if (strcmp (arquivo, "-"))
       {
	    if ( (fclose (log)) == EOF )
	    {
		perror("fclose()");
	    }
	}
    if ( (fclose (saida)) == EOF )
    {
	perror("fclose()");
    }

    return 0;
}

void Ajuda (const char *cmd)
{
    printf("Uso: %s <arquiv_log> [opes]\n\n", cmd);
    printf("Opes:\n"
	   "  -h || --help		  essa mensagem\n"
	   "  -r || --restrict     	  restringe a sada s linhas que batem com as regras\n"
	   "  -c || --config <file> uses alternate config file\n"
	   "  -o || --output <file>  gravar em um arquivo diferente de /var/log/gklog\n\n");
    printf("Serao usados os padroes:\n");
    printf("      log:     /var/log/syslog\n");
    printf("      saida: /var/log/gklog\n\n");
}

int main(int argc, char *argv[])
{
    int i;
    char Saida[1024];
    char nomelog[255];

    if (argc <2)
    {
	printf("Uso: %s <arquiv_log> [opes]\n\n", argv[0]);
	printf("Serao usados os padroes:\n");
	printf("      log:     /var/log/syslog\n");
	printf("      saida: /var/log/gklog\n\n");
    }

    strcpy (nomelog, "/var/log/syslog");
    strcpy (Saida, SAIDA);

	for (i = 0 ; i < argc ; i++)
	{
		if (!strcmp(argv[i], "-h") ||
			!strcmp (argv[i], "--help"))
		{
			Ajuda (argv[0]);
			return 0;
		}
		if (!strcmp(argv[i], "-c") ||
			!strcmp (argv[i], "--config"))
		{
			i++;
			bzero (conf, 256);
			strcpy (conf, argv[i]);
		}
		if (!strcmp(argv[i], "-o") ||
			!strcmp (argv[i], "--output"))
		{
			i++;
			strcpy (Saida, argv[i]);
		}
		if (!strcmp(argv[i], "-r") ||
			!strcmp (argv[i], "--restrict"))
		{
			restrict = 1;
		}
	}

    if (argc >= 2)
    {
	strcpy (nomelog, argv[1]);
    }

	if(!strcmp (nomelog, "-"))
	{	
		while (1)
		{
			if ( (LerLog (nomelog, Saida)) == 1)
	    		{        	
				printf("Erro na leitura de log\n\n");
				return 1;
	  		}
	  	}
	  }
	  else
	  {
		if ( (LerLog (nomelog, Saida)) == 1)
		{
		printf("Erro na leitura de log\n\n");
		return 1;
		}
	}

    return 0;

}
